<template>
  <main role="main" class="pf-c-page__main" tabindex="-1" id="create-session">
    <section class="pf-c-page__main-section">
      <div class="pf-l-bullseye__item">
        <div class="pf-c-card">
          <div id="header-title" class="pf-c-card__header pf-c-title pf-m-2xl">
            Create Session
          </div>
          <div class="pf-c-card__body">
            <form novalidate class="pf-c-form" @submit="create">
              <div class="pf-c-form__group">
                <label
                  class="pf-c-form__label"
                  for="help-text-simple-form-name"
                >
                  <span class="pf-c-form__label-text">Name</span>
                  <span class="pf-c-form__label-required" aria-hidden="true">
                    &#42;
                  </span>
                </label>
                <input
                  type="text"
                  id="name"
                  class="pf-c-form-control"
                  v-model="session.name"
                  required
                  v-bind:aria-invalid="
                    this.session.name.length == 0 && formSubmitted
                  "
                />
              </div>
              <div class="pf-c-form__group">
                <label
                  class="pf-c-form__label"
                  for="help-text-simple-form-name"
                >
                  <span class="pf-c-form__label-text">Date</span>
                  <span class="pf-c-form__label-required" aria-hidden="true">
                    &#42;
                  </span>
                </label>
                <input
                  type="date"
                  id="date"
                  class="pf-c-form-control"
                  v-model="session.date"
                  required
                  v-bind:aria-invalid="
                    this.session.date.length == 0 && formSubmitted
                  "
                />
              </div>
              <div class="pf-c-form__group pf-m-action pf-c-pagination">
                <div class="pf-c-form__actions">
                  <button
                    type="submit"
                    id="createSession"
                    class="pf-c-button pf-m-primary"
                  >
                    Save
                  </button>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
    </section>
    <Modal
      id="message"
      name="message"
      v-show="isModalVisible"
      @close="closeModal"
    >
      <h1 class="pf-c-title pf-m-2xl" id="modal-title">
        Take turns says
      </h1>
      <div class="pf-c-modal-box__body" id="modal-description">
        <div id="created-message" v-if="error.length == 0 && !formSubmitted">
          <strong>That's Amazing!</strong> Your session was registered.
        </div>
        <div id="created-message" v-if="error.length > 0 && !formSubmitted">
          <strong>I'm sorry!</strong>
          But we has an error trying to do the action, please try again later.
        </div>
        <div
          id="loading"
          class="pf-u-text-align-center"
          v-if="error.length == 0 && formSubmitted"
        >
          <span
            class="pf-c-spinner"
            role="progressbar"
            aria-valuetext="Loading..."
          >
            <span class="pf-c-spinner__clipper"></span>
            <span class="pf-c-spinner__lead-ball"></span>
            <span class="pf-c-spinner__tail-ball"></span>
          </span>
          <span class="pf-u-display-block pf-u-text-align-center">
            We are working for you, wait please ...
          </span>
        </div>
      </div>
      <footer
        class="pf-c-modal-box__footer pf-m-align-right"
        v-if="error.length == 0 && !formSubmitted"
      >
        <router-link
          name="finish-button"
          to="/"
          class="pf-c-button pf-m-primary"
          type="button"
        >
          Ok! thanks
        </router-link>
      </footer>
    </Modal>
  </main>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import axios from "axios";
import Modal from "../components/Modal.vue";
import { uuid } from "vue-uuid";
import Session from "../types/session";

@Component({
  components: { Modal }
})
export default class CreateSession extends Vue {
  private apiUrl: string = process.env.VUE_APP_API_URL;
  private isModalVisible = false;
  private formSubmitted = false;
  private error: string[] = [];
  private session: Session = {
    id: uuid.v1(),
    name: "",
    date: "",
    status: ""
  };

  private create(event: Event): void {
    event.preventDefault();
    this.formSubmitted = true;
    this.isModalVisible = true;
    if (this.session.name && this.session.date) {
      axios
        .post(`${this.apiUrl}/api/session`, this.session)
        .then(response => {
          if (response.status == 200) {
            this.formSubmitted = false;
          }
        })
        .catch(error => {
          this.formSubmitted = false;
          this.error.push(error.message);
        });
    }
  }

  private closeModal(): void {
    this.isModalVisible = false;
  }
}
</script>
